﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace GPSLib
{
    public class GPSDataDispatcher
    {
        public Thread readThread;
        private List<GPSDataObserver> observers = new List<GPSDataObserver>();
        public GPSSource source;
        public bool quitting = false;

        public GPSDataDispatcher(GPSSource _source)
        {
            source = _source;
            readThread = new Thread(startProcessing);
        }

        private void dataRecieved(NMEAData data)
        {
            foreach (GPSDataObserver observer in observers)
            {
                observer.GPSSourceUpdate(data);
            }
        }

        private void dataClosed()
        {
            foreach (GPSDataObserver observer in observers)
            {
                observer.GPSSourceClosed();
            }
        }

        public void addObserver(GPSDataObserver observer)
        {
            observers.Add(observer);
        }

        public void startup()
        {
            readThread.Start(this);
        }

        public void stop()
        {
            quitting = true;
        }

        protected void BlockingReadLine()
        {
            while (quitting == false && source.isOpen())
            {
                NMEAData[] dataArr = source.getNMEAData();
                foreach (NMEAData data in dataArr)
                {
                    dataRecieved(data);
                }
            }
        }

        private static void startProcessing(object data)
        {
            GPSDataDispatcher disp = (GPSDataDispatcher)data;
            disp.BlockingReadLine();
        }

    }
}
